require 'payzen/version'
require 'digest/sha1'
require 'json'
require 'active_support/all'

module Payzen
  autoload :Config, 'payzen/config'
  autoload :PaymentResponse, 'payzen/payment_response'

  cattr_accessor(:config)

  def self.setup
    self.config ||= Config.new
    yield config
  end

  def self.transaction(params)
    params             = config.vads_params.merge(params)
    signature          = signature(params)
    params[:signature] = signature
    params
  end

  def self.signature(params)
    string_to_hash = (params.select { |k, v| v && k.to_s.start_with?('vads_') }.
        sort_by(&:first).map(&:second) << config.certificate).join('+')
    Digest::SHA1.hexdigest(string_to_hash)
  end
end
