module Payzen
  class Config
    DEFAULTS = {
        target_url:       'https://secure.payzen.eu/vads-payment/',
        vads_action_mode: 'INTERACTIVE',
        vads_ctx_mode:    'TEST',
        vads_contrib:     'Wizypay',
        vads_page_action: 'PAYMENT',
        vads_return_mode: 'POST',
        vads_version:     'V2',
        vads_payment_config:  'SINGLE',
        vads_currency:    '978',
        vads_language:    'fr',
        # INTERACTIVE: card information entered in Systempay payment page
        # SILENT: card info captured in merchant's site (contract option)
        # or 'PRODUCTION'
        # or 'GET', but request in GET could be too large
        # 978 EUR; 840 USD'
    }.freeze

    attr_accessor :certificate,
                  :target_url,
                  :vads_action_mode,
                  :vads_contrib,
                  :vads_ctx_mode,
                  :vads_currency,
                  :vads_language,
                  :vads_page_action,
                  :vads_payment_config,
                  :vads_return_mode,
                  :vads_shop_name,
                  :vads_shop_url,
                  :vads_site_id,
                  :vads_validation_mode,
                  :vads_version

    def initialize
      DEFAULTS.each do |k, v|
        send("#{k}=", v)
      end
    end

    def vads_params
      Hash[instance_variables.
               select { |v| v.to_s.starts_with? '@vads_' }.
               map { |v| [v[1..-1].to_sym, instance_variable_get(v)] }]
    end
  end
end
